package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluate;
import com.gic.evaluate.qo.EvaluateQO;
import com.gic.evaluate.qo.StoreScoreQO;
import com.gic.evaluate.qo.StoreTrendQO;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface TabEvaluateMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer evaluateId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluate record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluate record);

    /**
     * 根据主键查询
     *
     * @param evaluateId 主键
     * @return 实体对象
     */
    TabEvaluate selectByPrimaryKey(Integer evaluateId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluate record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluate record);

    Page<TabEvaluate> listEvaluate(EvaluateQO evaluateQO);

    Integer countEvaluate(EvaluateQO evaluateQO);

    void updateShowStatus(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") List<Integer> evaluateId, @Param("showStatus") Integer showStatus);

    void updateTopHotStatus(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") Integer evaluateId, @Param("topHotStatus") Integer topHotStatus);

    void updateMaliciousStatus(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") Integer evaluateId, @Param("maliciousStatus") Integer maliciousStatus);

    Map<String, Long> getTotalChart(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("ids") List<Integer> storeIdList);

    Map<String, Long> getGoodsCountChart(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("ids") List<Integer> storeIdList);

    Map<String, Long> getStoreCountChart(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("ids") List<Integer> storeIdList);

    Map<String, Long> getServiceCountChart(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("ids") List<Integer> storeIdList);

    List<Map<String, Object>> listTrendEvaluate(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("goodEvaluateStatus") Integer goodEvaluateStatus, @Param("ids") List<Integer> storeIdList);

    Page<Map<String, Object>> listStoreScore(StoreScoreQO storeScoreQO);

    Map<String, Object> getTotalStoreScore(StoreScoreQO storeScoreQO);

    Page<Map<String, Object>> listTrend(StoreTrendQO storeTrendQO);

    TabEvaluate getEvaluateByOrderNumber(@Param("enterpriseId") Integer enterpriseId, @Param("orderNumber") String orderNumber);

    List<Map<String, Object>> evaluateQuickChart(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("tagType") Integer tagType, @Param("ids") List<Integer> storeIdList);

    @MapKey("statisticsDate")
    Map<String, Map<String, Object>> listEvaluateTrendByYear(@Param("enterpriseId") Integer enterpriseId, @Param("replyType") Integer replyType);

    @MapKey("statisticsDate")
    Map<String, Map<String, Object>> listEvaluateTrendByMonth(@Param("enterpriseId") Integer enterpriseId, @Param("replyType") Integer replyType, @Param("firstDate") Date firstDate);

    @MapKey("statisticsDate")
    Map<String, Map<String, Object>> listEvaluateTrendByDay(@Param("enterpriseId") Integer enterpriseId, @Param("replyType") Integer replyType, @Param("firstDate") Date firstDate);

    Integer getStoreTopHot(@Param("enterpriseId") Integer enterpriseId, @Param("storeId") Integer storeId);

    List<Integer> listAllEvaluateId(@Param("enterpriseId") Integer enterpriseId);

    Set<Integer> getStoreHasTopHot(@Param("enterpriseId") Integer enterpriseId, @Param("ids") List<Integer> storeIdList);

    Integer countEvaluateTrend(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("ids") List<Integer> storeIdList, @Param("quickReplyType") Integer quickReplyType);
}